########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    4 chars;
########    #######    ########    #######    ########    ########
module Dialect
  class Lookup    
  
    
    def dialectLookup(args,state,viewId,viewType)            
      queryName = args[:dialectLookupQuery][:queryName]
      if args[:objects][viewId][:links][args[:dialectLookupQuery][:cClass]].is_a?(Hash)
        args[:objects][viewId][:links][args[:dialectLookupQuery][:cClass]].each do |_conPairId, conProp|
         
          
         if   conProp[:viewID] == viewId and
              conProp[:fClass] =~ /^#{args[:dialectLookupQuery][:fClass]}/ and 
              conProp[:fFqn] =~ /^#{args[:dialectLookupQuery][:fFqn]}/ and
              conProp[:tClass] =~ /^#{args[:dialectLookupQuery][:tClass]}/ and
              conProp[:tFqn] =~ /^#{args[:dialectLookupQuery][:tFqn]}/
           
              

              conProp[:cClass] = args[:dialectLookupQuery][:cClass]
              prop = getProp(args,state,conProp,'from')
              conProp[:fProp] = prop if not prop.nil?
              prop = getProp(args,state,conProp,'to')
              conProp[:tProp] = prop if not prop.nil?
              
              if args[:dialectLookupQuery].has_key?(:fPropKey)
                conProp[:fProp][args[:dialectLookupQuery][:fPropKey]] == args[:dialectLookupQuery][:fPropValue] ? store = true : store = false
              else
                store = true
              end
              
              if store == true    
#                 Dialog.logger.debug "In view #{viewId} by query '#{queryName}' we have a #{args[:dialectLookupQuery][:cClass]} connection: CONNPARID #{conPairId} FROM fClass = #{conProp[:fClass]} fqn = #{conProp[:fFqn]}  fId = #{conProp[:fId]}  NAME #{conProp[:fName]} FPROP #{conProp[:fProp]} [[ TO ]] tClass = #{conProp[:tClass]} fqn = #{conProp[:tFqn]}  tId = #{conProp[:tId]} NAME #{conProp[:tName]} TPROP #{conProp[:tProp]}\n"         
                
#                 hash_fName = Digest::SHA256.hexdigest("#{conProp[:fName]}")[0..20]
                hash_tName = Digest::SHA256.hexdigest("#{conProp[:tName]}")[0..20]
                hash_fName_fId_tId = Digest::SHA256.hexdigest("#{conProp[:fName]}#{conProp[:fOID]}#{conProp[:tOID]}")[0..20]              
  #               puts conProp
                args[:stages][state[:dialectFolder]][viewType] ||= {}
                args[:stages][state[:dialectFolder]][viewType][state[:myAppName]] ||= {}
                case viewType
                when :perView
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName] ||= {}              
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName][:lookup] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName][:lookup][hash_tName] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName][:lookup][hash_tName][hash_fName_fId_tId] = conProp                   
                when :constructors
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName] ||= {}              
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName][:lookup] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName][:lookup][hash_tName] ||= {}
                  args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName][:lookup][hash_tName][hash_fName_fId_tId] = conProp                  
                end
              end
                
          end
        end
      end
    end
    
    
    
    def getProp(_args,state,conProp,direction)
      rows = {}
      
      case direction
      when 'from'
        eID  = conProp[:fEID]
        eVer = conProp[:fEVer]        
      when 'to'
        eID  = conProp[:tEID]
        eVer = conProp[:tEVer]        
      end
      
      state[:dbhandler].execute( "
        select name, value                  
        from properties 
        where parent_id like '#{eID}' AND
        parent_version = '#{eVer}' AND
        name NOT LIKE 'fqn'
      ")  do |row|
#             Bot.logger.debug "### ROW #{eID} #: #{row}"  
#             rows[eID] ||= {}
            rows[row[0].to_sym] = row[1]             
      end  
      return rows if not rows.empty?
    end

    
    def dialectRepack(args, state, viewId, viewType, queryName)
      
      case viewType
      when :perView
        if not args[:stages][state[:dialectFolder]][viewType][state[:myAppName]].nil?
          base = args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName]          
        else
          base = false
        end
      when :constructors
        base = args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName]          
      end
      if base.is_a?(Hash)
        repackNames = [:fFqn, :tFqn, :fOID, :tOID, :fEID, :tEID]              
        base[:repack] = {}      
        repackNames.each do |repackName|
          res = {}                     
          base[:repack][repackName] ||= {}      
          base[:lookup].each do |_tName, hash_tNameProp|
            hash_tNameProp.each do |_fName, hash_fNameProp|
              res[hash_fNameProp[repackName]] = hash_fNameProp
            end 
          end  
          case viewType          
          when :perView
            args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][viewId][queryName][:repack][repackName] = res      
          when :constructors
            args[:stages][state[:dialectFolder]][viewType][state[:myAppName]][queryName][:repack][repackName] = res
          end          
        end      
      end
    end
    
    
    def lookupDebug(name, prop)
      Bot.logger.debug "### #{name} :: F:: '#{prop[:fName]}' fqn:#{prop[:fFqn]} o:#{prop[:fOID]} e:#{prop[:fEID]} p '#{prop[:fProp]}' :: T :: '#{prop[:tName]}' fqn:#{prop[:tFqn]} o:#{prop[:tOID]} e:#{prop[:tEID]} p '#{prop[:tProp]}'"
    end
    
    
    def lookup_run(args, lookupStruct, state, viewId, viewType)
      lookupStruct.each do |type,lookups|
        lookups.each do |lookup|
        run = "lookup_#{type}_#{lookup}"
#           Dialog.logger.debug "### Dialect_lookup call - #{run}"        
          send(run, args, state, viewId, viewType)
        end
      end
    end
    
  
    
  end
end
