########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    4 chars;
########    #######    ########    #######    ########    ########
module Dialect
  class Lookup 
    
    
    def getObjects(args, state)
      args[:views].each do |viewId, viewProps|
        getObjectsFromSQL(args, state, viewId, viewProps)
      end
      args[:con_views].each do |viewId, viewProps|
        getObjectsFromSQL(args, state, viewId, viewProps)
      end      
      return args
    end
    
    def getObjectsFromSQL(args, state, viewId, _viewProps)
      
      args[:x] = {}
      viewIdOrig = viewId.to_s.tr("_", "-")
      args[:objects] ||= {}
      args[:objects][viewId] = {}
      rows={}
      links = {}
      i = 1

#  (views_objects.id in ('views_connections'.`source_object_id`) AND views_objects.id not in ('views_connections'.`target_object_id`)) 
      
      state[:dbhandler].execute( "
        select 
        views_objects.id, 
        elements.id, 
        elements.class,
        relationships.class, 
        elements.name, 
        views_connections.source_object_id, 
        views_connections.target_object_id,
        elements.documentation,
        relationships.version,
        elements.version,
        views_objects.element_version,
        properties.value
                                      
        from views_connections_in_view
        INNER JOIN views_connections ON views_connections_in_view.connection_id = views_connections.id
                                AND views_connections.version = (select max(views_connections.version) from views_connections where views_connections.id = views_connections_in_view.connection_id )
        INNER JOIN relationships ON relationships.id = views_connections.relationship_id 

        INNER JOIN views_objects ON (views_objects.id = views_connections.source_object_id OR  
                                  views_objects.id = views_connections.target_object_id) AND  

                                  views_objects.version = (select max(views_objects.version) from views_objects where (
                                  (views_objects.id in ('views_connections'.`target_object_id`) AND views_objects.id not in ('views_connections'.`source_object_id`))
                                  ))
                               
        INNER JOIN elements ON elements.id = views_objects.element_id AND elements.version = (select max(elements.version) from elements where elements.id in ('views_objects'.`element_id`))
        LEFT JOIN properties ON properties.parent_id = elements.id AND  
                                    properties.parent_version = (select max(properties.parent_version) from properties where properties.parent_id in ('elements'.`id`)) AND
                                    properties.name LIKE 'fqn'
                                      
      
          where views_connections_in_view.view_id like '#{viewIdOrig}' 
          and views_connections_in_view.view_version = (select max(views_connections_in_view.view_version) from views_connections_in_view where views_connections_in_view.view_id like '#{viewIdOrig}')
          and relationships.class in ('AggregationRelationship', 'TriggeringRelationship', 'FlowRelationship', 'AccessRelationship', 'SpecializationRelationship', 'CompositionRelationship', 'ServingRelationship', 'RealizationRelationship') 
          and (elements.class LIKE 'Application%' OR elements.class in ('DataObject', 'Grouping'))
                                      and elements.version = (select max(elements.version) from elements where elements.id in ('views_objects'.`element_id`))

      ")  do |row|
#                 Bot.logger.debug "### ROW ##{i}: #{row}" 

#             hash_tName_fId_tId = Digest::SHA256.hexdigest("#{row[0]}_#{row[4]}_#{row[5]}")[0..20]  
            hash_tName_fId_tId = Digest::SHA256.hexdigest("#{row[4]}_#{row[5]}")[0..20]                    
            rows[row[0]] ||= {}
            rows[row[0]][:e_id] = row[1]            
            rows[row[0]][:e_class] = row[2]
            rows[row[0]][:o_name]  = row[4]
            rows[row[0]][:e_doc] = row[7]
            rows[row[0]][:e_ver] = row[9]            
            rows[row[0]][:p_fqn]  = row[11]                        

            
            rows[row[0]][row[3]] ||= {}            
            rows[row[0]][row[3]][hash_tName_fId_tId] ||= {}  
            rows[row[0]][row[3]][hash_tName_fId_tId] = {from: row[5], to: row[6] }
            i = i + 1
      end
                    
      i = 1
        rows.each do |_objId, objProps|            
          objProps.each do |objProp, objVal|
            if objProp.to_s =~ /Relationship/
              links[objProp] ||= {}                
              objVal.sort.map do |conPairId, conProps| 
                
                if ! rows[conProps[:from]].nil? and ! rows[conProps[:to]].nil?
                  links[objProp][conPairId] ||= {}
  #                 Bot.logger.debug "### AAA #{i}: #{rows[conProps[:from]] }"                    
                  links[objProp][conPairId][:connUUID]  = "#{conProps[:from]}#{conProps[:to]}".unpack("H8H4H4H4H12").join('-') 
                  links[objProp][conPairId][:viewID]    = viewId                   
                  links[objProp][conPairId][:fOID]      = conProps[:from].tr("-", "_")
                  links[objProp][conPairId][:fEID]      = rows[conProps[:from]][:e_id].tr("-", "_")
                  links[objProp][conPairId][:fEVer]     = rows[conProps[:from]][:e_ver]
                  links[objProp][conPairId][:fDoc]      = rows[conProps[:from]][:e_doc] == "" ? 0 : rows[conProps[:from]][:e_doc]
                  links[objProp][conPairId][:fName]     = rows[conProps[:from]][:o_name]                
                  links[objProp][conPairId][:fClass]    = rows[conProps[:from]][:e_class]
                  links[objProp][conPairId][:fFqn]      = rows[conProps[:from]][:p_fqn]                
                  
                  
                  links[objProp][conPairId][:tOID]       = conProps[:to].tr("-", "_")
                  links[objProp][conPairId][:tEID]      = rows[conProps[:to]][:e_id].tr("-", "_")                               
                  links[objProp][conPairId][:tEVer]     = rows[conProps[:to]][:e_ver]
                  links[objProp][conPairId][:tDoc]      = rows[conProps[:to]][:e_doc] == "" ? 0 : rows[conProps[:to]][:e_doc]
                  links[objProp][conPairId][:tName]     = rows[conProps[:to]][:o_name]                
                  links[objProp][conPairId][:tClass]    = rows[conProps[:to]][:e_class]
                  links[objProp][conPairId][:tFqn]      = rows[conProps[:to]][:p_fqn] 
#                     Bot.logger.debug "### AAA #{i}: #{links[objProp][conPairId]}"
                  i = i + 1
                end
              end
            end
          end
        end
      
      args[:objects][viewId][:objects] = rows 
      args[:objects][viewId][:links] = links
    end
  end
    
end
